exercises/api/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  scope module: :web do
    root 'home#index'

    resources :users
  end

  # BEGIN
  namespace :api do
    resources :users, only: %i[index show]
  end
  # END

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

exercises/api/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/api/app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  validates :first_name, presence: true
  validates :email, presence: true
end

exercises/api/app/controllers/api/application_controller.rb
# frozen_string_literal: true

module Api
  class ApplicationController < ApplicationController
    # BEGIN
    respond_to :json
    # END
  end
end

exercises/api/app/controllers/api/users_controller.rb
# frozen_string_literal: true

module Api
  class UsersController < Api::ApplicationController
    # BEGIN
    before_action :set_user, only: :show

    def index
      respond_with User.all
    end

    def show
      respond_with @user
    end

    private

    def set_user
      @user = User.find(params[:id])
    end
    # END
  end
end

exercises/api/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/api/app/controllers/web/application_controller.rb
# frozen_string_literal: true

module Web
  class ApplicationController < ApplicationController
  end
end

exercises/api/app/controllers/web/home_controller.rb
# frozen_string_literal: true

module Web
  class HomeController < Web::ApplicationController
    def index; end
  end
end

exercises/api/app/controllers/web/users_controller.rb
# frozen_string_literal: true

module Web
  class UsersController < Web::ApplicationController
    def index
      @users = User.all
    end

    def show
      @user = User.find params[:id]
    end

    def new
      @user = User.new
    end

    def edit
      @user = User.find params[:id]
    end

    def create
      @user = User.new(user_params)

      if @user.save
        redirect_to @user, notice: t('success')
      else
        render :new, status: :unprocessable_entity
      end
    end

    def update
      @user = User.find params[:id]

      if @user.update(user_params)
        redirect_to @user, notice: t('success')
      else
        render :edit, status: :unprocessable_entity
      end
    end

    def destroy
      @user = User.find params[:id]

      @user.destroy

      redirect_to users_url, notice: t('success')
    end

    private

    def user_params
      params.require(:user).permit(
        :first_name,
        :last_name,
        :email,
        :address,
        :password_digest,
        :balance
      )
    end
  end
end

exercises/api/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/api/app/views/web/users/_form.html.slim
= simple_form_for(@user) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  = f.input :first_name
  = f.input :last_name
  = f.input :email
  = f.input :address
  = f.input :balance
  = f.input :state

  = f.button :submit, class: 'btn btn-success mt-4 btn-block'

exercises/api/app/views/web/users/edit.html.slim
- content_for :title do
  = t('.edit_user')

== render 'form'

hr

.d-flex
  = link_to t('show'), @user, class: 'btn btn-outline-primary me-2'
  = link_to t('back'), :back, class: 'btn btn-outline-primary'

exercises/api/app/views/web/users/index.html.slim
- content_for :title do
  = t('.users')

table.table.table-striped.table-hover.mb-5
  thead
    tr
      th{ scope: :col } #
      th{ scope: :col } = t('.first_name')
      th{ scope: :col } = t('.last_name')
      th{ scope: :col } = t('.email')
      th

  tbody
    - @users.each_with_index do |user, i|
      tr
        th{ scope: :col } = i + 1
        td = user.first_name
        td = user.last_name
        td = user.email
        td.d-flex
          = link_to t('show'), user, class: 'me-4'
          = link_to t('edit'), edit_user_path(user), class: 'me-4'
          = link_to t('destroy'), user, data: { confirm: t('destroy_confirmation') }, method: :delete

= link_to t('.new_user'), new_user_path, class: 'btn btn-primary'

exercises/api/app/views/web/users/new.html.slim
- content_for :title do
  = t('new_user')

== render 'form'

hr

= link_to t('back'), :back, class: 'btn btn-outline-primary'

exercises/api/app/views/web/users/show.html.slim
- content_for :title do
  = @user.first_name

p
  strong.me-2 = t('.last_name')
  = @user.last_name

p
  strong.me-2 = t('.email')
  = @user.email

p
  strong.me-2 = t('.balance')
  = @user.balance

p
  strong.me-2 = t('.address')
  = @user.address

p
  strong.me-2 = t('.state')
  = @user.state

hr

.d-flex
  = link_to t('edit'), edit_user_path(@user), class: 'btn btn-outline-primary me-2'
  = link_to t('back'), :back, class: 'btn btn-outline-primary'